
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATtiny26
;Program type           : Application
;Clock frequency        : 1,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Automatic register allocation for global variables: On
;Smart register allocation: Off

	#define _MODEL_TINY_

	#pragma AVRPART ADMIN PART_NAME ATtiny26
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x00DF
	.EQU __DSTACK_SIZE=0x0020
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _vol=R4
	.DEF _trigger=R5
	.DEF _timer=R6
	.DEF _mute=R7
	.DEF _enc_state1=R8
	.DEF _enc_state2=R9
	.DEF _enc_data1=R10
	.DEF _enc_data2=R11

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,__CLEAR_SRAM_SIZE
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;#include <tiny26.h>          //  1 
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>           // 
;
;#define MUTE      0xC0       //   
;#define SPEED     10         //    
;
;#define enc_A1    PINB.5     //   
;#define enc_B1    PINB.6     //   
;#define enc_E1    PINB.4     //   
;
;#define enc_A2    PINA.4     //   
;#define enc_B2    PINA.5     //   
;#define enc_E2    PINA.3     //   
;
;#define PCLOCK    PORTA.7    //  
;#define SCL       DDRA.7     //   7448
;#define PDATA     PORTA.6    //  
;#define SDA       DDRA.6     //   7448
;
;#define LED_1     PORTA.0    //  1 
;#define LED_2     PORTA.1    //  2 
;#define LED_3     PORTA.2    //  3 
;#define LED_4     PORTB.0    //  4 
;#define LED_5     PORTB.1    //  5 
;#define LED_6     PORTB.2    //  6 
;#define LED_7     PORTB.3    //  7 
;
;void EncoderScan1 (void);           //  1
;void EncoderScan2 (void);            //  2
;void LED_bar  (unsigned char level); //  
;void TDA_send (unsigned char value); //   
;void TWI_send (unsigned char data);  //    i2c
;void TWI_start(void);                //   i2c
;void TWI_stop (void);                //   i2c
;void save_vol (void);                //  
;
;unsigned char vol;           //  
;unsigned char trigger;       //  
;unsigned char timer;         //   
;unsigned char mute;          //   
;
;eeprom unsigned char e_vol; //  
;eeprom unsigned char e_mute;//    
;
;unsigned char enc_state1;    //    1
;unsigned char enc_state2;    //    2
;unsigned char enc_data1;     //    1
;unsigned char enc_data2;     //    2
;
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0033  {

	.CSEG
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0034   timer++;           //   
	INC  R6
; 0000 0035   if(timer>20)       //   600 ?
	LDI  R30,LOW(20)
	CP   R30,R6
	BRSH _0x3
; 0000 0036    {
; 0000 0037     if(e_vol!=vol)   //   
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMRDB
	CP   R4,R30
	BREQ _0x4
; 0000 0038     {e_vol=vol;}     //  , 
	MOV  R30,R4
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMWRB
; 0000 0039     delay_ms(5);     //   
_0x4:
	LDI  R26,LOW(5)
	LDI  R27,0
	RCALL _delay_ms
; 0000 003A 
; 0000 003B     if(e_mute!=mute) //   
	LDI  R26,LOW(_e_mute)
	LDI  R27,HIGH(_e_mute)
	RCALL __EEPROMRDB
	CP   R7,R30
	BREQ _0x5
; 0000 003C     {e_mute=mute;}   //  , 
	MOV  R30,R7
	LDI  R26,LOW(_e_mute)
	LDI  R27,HIGH(_e_mute)
	RCALL __EEPROMWRB
; 0000 003D     delay_ms(5);     //   
_0x5:
	LDI  R26,LOW(5)
	LDI  R27,0
	RCALL _delay_ms
; 0000 003E 
; 0000 003F     timer=0;         //  
	CLR  R6
; 0000 0040     #asm("cli")      //    
	cli
; 0000 0041    }                 //    
; 0000 0042  }
_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;//=================== Encoder ==================
;void tda_plavno (unsigned char direction)
; 0000 0046  {
_tda_plavno:
; .FSTART _tda_plavno
; 0000 0047   unsigned char steps;  //  
; 0000 0048   unsigned char tmp=80; //  
; 0000 0049 
; 0000 004A   if(direction)         // 1 - 
	ST   -Y,R26
	RCALL __SAVELOCR2
;	direction -> Y+2
;	steps -> R16
;	tmp -> R17
	LDI  R17,80
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x6
; 0000 004B    {
; 0000 004C     steps=80;           //   
	LDI  R16,LOW(80)
; 0000 004D     for(tmp-=vol; tmp>0; tmp--) //  +
	SUB  R17,R4
_0x8:
	CPI  R17,1
	BRLO _0x9
; 0000 004E      {
; 0000 004F       steps--;          //  
	SUBI R16,1
; 0000 0050       TDA_send(steps);  //  
	MOV  R26,R16
	RCALL _TDA_send
; 0000 0051       delay_ms(SPEED);  //   
	LDI  R26,LOW(10)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0052       LED_bar(steps);   //  
	MOV  R26,R16
	RCALL _LED_bar
; 0000 0053      }
	SUBI R17,1
	RJMP _0x8
_0x9:
; 0000 0054    }
; 0000 0055   else                  // 0 - 
	RJMP _0xA
_0x6:
; 0000 0056    {
; 0000 0057     steps=vol;          //   
	MOV  R16,R4
; 0000 0058     for(tmp-=vol; tmp>0; tmp--) //  -
	SUB  R17,R4
_0xC:
	CPI  R17,1
	BRLO _0xD
; 0000 0059      {
; 0000 005A       steps++;          //  
	SUBI R16,-1
; 0000 005B       if(steps!=80) TDA_send(steps);  //  
	CPI  R16,80
	BREQ _0xE
	MOV  R26,R16
	RCALL _TDA_send
; 0000 005C       delay_ms(SPEED);  //   
_0xE:
	LDI  R26,LOW(10)
	LDI  R27,0
	RCALL _delay_ms
; 0000 005D       LED_bar(steps);   //  
	MOV  R26,R16
	RCALL _LED_bar
; 0000 005E      }
	SUBI R17,1
	RJMP _0xC
_0xD:
; 0000 005F     TDA_send(MUTE);     //  mute
	LDI  R26,LOW(192)
	RCALL _TDA_send
; 0000 0060    }
_0xA:
; 0000 0061 
; 0000 0062  }
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
; .FEND
;
;//=================== Encoder ==================
;void main(void)
; 0000 0066  {
_main:
; .FSTART _main
; 0000 0067   DDRA=0b00000111;      //  
	LDI  R30,LOW(7)
	OUT  0x1A,R30
; 0000 0068   DDRB=0b10001111;      //  
	LDI  R30,LOW(143)
	OUT  0x17,R30
; 0000 0069 
; 0000 006A   TDA_send(MUTE);       //  mute
	LDI  R26,LOW(192)
	RCALL _TDA_send
; 0000 006B 
; 0000 006C   vol=e_vol;            //  
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMRDB
	MOV  R4,R30
; 0000 006D   if(vol>80)            //   
	LDI  R30,LOW(80)
	CP   R30,R4
	BRSH _0xF
; 0000 006E   {e_vol=80; vol=80;}   //  
	LDI  R26,LOW(_e_vol)
	LDI  R27,HIGH(_e_vol)
	RCALL __EEPROMWRB
	MOV  R4,R30
; 0000 006F   delay_ms(5);          //  
_0xF:
	LDI  R26,LOW(5)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0070 
; 0000 0071   mute=e_mute;          //  
	LDI  R26,LOW(_e_mute)
	LDI  R27,HIGH(_e_mute)
	RCALL __EEPROMRDB
	MOV  R7,R30
; 0000 0072   if(mute>1)            //   
	LDI  R30,LOW(1)
	CP   R30,R7
	BRSH _0x10
; 0000 0073   {mute=0; e_mute=0;}   //  
	CLR  R7
	LDI  R26,LOW(_e_mute)
	LDI  R27,HIGH(_e_mute)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 0074   delay_ms(5);          //  
_0x10:
	LDI  R26,LOW(5)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0075 
; 0000 0076   if(!mute && vol!=80)  //    0, ..
	TST  R7
	BRNE _0x12
	LDI  R30,LOW(80)
	CP   R30,R4
	BRNE _0x13
_0x12:
	RJMP _0x11
_0x13:
; 0000 0077   {tda_plavno(1);}      //   
	LDI  R26,LOW(1)
	RCALL _tda_plavno
; 0000 0078 
; 0000 0079   TCCR0=0x03;           //   
_0x11:
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 007A   TIMSK=0x02;           //   
	LDI  R30,LOW(2)
	OUT  0x39,R30
; 0000 007B 
; 0000 007C   while(1)
_0x14:
; 0000 007D    {
; 0000 007E     if(!enc_E1 && trigger==0) {trigger=1;} //    1
	SBIC 0x16,4
	RJMP _0x18
	TST  R5
	BREQ _0x19
_0x18:
	RJMP _0x17
_0x19:
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 007F     if( enc_E1 && trigger==1)  //    1
_0x17:
	SBIS 0x16,4
	RJMP _0x1B
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
; 0000 0080      {trigger=0;
	CLR  R5
; 0000 0081       mute^=1;                 //  
	LDI  R30,LOW(1)
	EOR  R7,R30
; 0000 0082 
; 0000 0083       if(mute){tda_plavno(0);} //  
	TST  R7
	BREQ _0x1D
	LDI  R26,LOW(0)
	RJMP _0x96
; 0000 0084       else    {tda_plavno(1);} //  
_0x1D:
	LDI  R26,LOW(1)
_0x96:
	RCALL _tda_plavno
; 0000 0085 
; 0000 0086       save_vol();              //  
	RCALL _save_vol
; 0000 0087      }
; 0000 0088     if(!enc_E2 && trigger==0) {trigger=2;} //    2
_0x1A:
	SBIC 0x19,3
	RJMP _0x20
	TST  R5
	BREQ _0x21
_0x20:
	RJMP _0x1F
_0x21:
	LDI  R30,LOW(2)
	MOV  R5,R30
; 0000 0089     if( enc_E2 && trigger==2)  //    2
_0x1F:
	SBIS 0x19,3
	RJMP _0x23
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ _0x24
_0x23:
	RJMP _0x22
_0x24:
; 0000 008A      {trigger=0;
	CLR  R5
; 0000 008B       mute^=1;                 //  
	LDI  R30,LOW(1)
	EOR  R7,R30
; 0000 008C 
; 0000 008D       if(mute){tda_plavno(0);} //  
	TST  R7
	BREQ _0x25
	LDI  R26,LOW(0)
	RJMP _0x97
; 0000 008E       else    {tda_plavno(1);} //  
_0x25:
	LDI  R26,LOW(1)
_0x97:
	RCALL _tda_plavno
; 0000 008F 
; 0000 0090       save_vol();              //  
	RCALL _save_vol
; 0000 0091      }
; 0000 0092 
; 0000 0093     EncoderScan1();   //   1
_0x22:
	RCALL _EncoderScan1
; 0000 0094     EncoderScan2();   //   2
	RCALL _EncoderScan2
; 0000 0095 
; 0000 0096     if(enc_data1==1 || enc_data2==1)  // 1 - 
	LDI  R30,LOW(1)
	CP   R30,R10
	BREQ _0x28
	CP   R30,R11
	BRNE _0x27
_0x28:
; 0000 0097      {
; 0000 0098       enc_data1=0; //   
	CLR  R10
; 0000 0099       enc_data2=0; //   
	CLR  R11
; 0000 009A 
; 0000 009B       if(vol<80 && !mute)   //   mute
	LDI  R30,LOW(80)
	CP   R4,R30
	BRSH _0x2B
	TST  R7
	BREQ _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
; 0000 009C        {
; 0000 009D         vol++;     //  
	INC  R4
; 0000 009E 
; 0000 009F         if(vol==80) {TDA_send(MUTE);}  //  80,   
	LDI  R30,LOW(80)
	CP   R30,R4
	BRNE _0x2D
	LDI  R26,LOW(192)
	RJMP _0x98
; 0000 00A0         else        {TDA_send(vol);}   //   
_0x2D:
	MOV  R26,R4
_0x98:
	RCALL _TDA_send
; 0000 00A1         LED_bar(vol);  //  
	MOV  R26,R4
	RCALL _LED_bar
; 0000 00A2 
; 0000 00A3         save_vol();//  
	RCALL _save_vol
; 0000 00A4        }
; 0000 00A5      }
_0x2A:
; 0000 00A6     if(enc_data1==2 || enc_data2==2)  // 2 - 
_0x27:
	LDI  R30,LOW(2)
	CP   R30,R10
	BREQ _0x30
	CP   R30,R11
	BRNE _0x2F
_0x30:
; 0000 00A7      {
; 0000 00A8       enc_data1=0; //   
	CLR  R10
; 0000 00A9       enc_data2=0; //   
	CLR  R11
; 0000 00AA 
; 0000 00AB       if(mute) vol=80; //     
	TST  R7
	BREQ _0x32
	LDI  R30,LOW(80)
	MOV  R4,R30
; 0000 00AC 
; 0000 00AD       if(vol>0)    //    
_0x32:
	LDI  R30,LOW(0)
	CP   R30,R4
	BRSH _0x33
; 0000 00AE        {
; 0000 00AF         vol--;     //  
	DEC  R4
; 0000 00B0 
; 0000 00B1         if(vol<80) mute=0; //     +
	LDI  R30,LOW(80)
	CP   R4,R30
	BRSH _0x34
	CLR  R7
; 0000 00B2 
; 0000 00B3         TDA_send(vol); //    I2C
_0x34:
	MOV  R26,R4
	RCALL _TDA_send
; 0000 00B4         LED_bar(vol);  //  
	MOV  R26,R4
	RCALL _LED_bar
; 0000 00B5 
; 0000 00B6         save_vol();    // 
	RCALL _save_vol
; 0000 00B7        }
; 0000 00B8      }
_0x33:
; 0000 00B9 
; 0000 00BA      delay_us(300);         //   
_0x2F:
	__DELAY_USB 100
; 0000 00BB    }
	RJMP _0x14
; 0000 00BC  }
_0x35:
	RJMP _0x35
; .FEND
;
;void EncoderScan1 (void)  //  1
; 0000 00BF  {
_EncoderScan1:
; .FSTART _EncoderScan1
; 0000 00C0   unsigned char enc_temp=0;         //
; 0000 00C1 
; 0000 00C2   if(enc_A1){enc_temp|=(1<<0);}      //  
	ST   -Y,R16
;	enc_temp -> R16
	LDI  R16,0
	SBIC 0x16,5
	ORI  R16,LOW(1)
; 0000 00C3   if(enc_B1){enc_temp|=(1<<1);}      //  
	SBIC 0x16,6
	ORI  R16,LOW(2)
; 0000 00C4 
; 0000 00C5   if(enc_state1==0)               // 
	TST  R8
	BRNE _0x38
; 0000 00C6    {
; 0000 00C7     if(enc_temp==2) enc_data1=2;
	CPI  R16,2
	BRNE _0x39
	LDI  R30,LOW(2)
	MOV  R10,R30
; 0000 00C8     if(enc_temp==1) enc_data1=1;
_0x39:
	CPI  R16,1
	BRNE _0x3A
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 00C9    }
_0x3A:
; 0000 00CA   if(enc_state1==3)               // 
_0x38:
	LDI  R30,LOW(3)
	CP   R30,R8
	BRNE _0x3B
; 0000 00CB    {
; 0000 00CC     if(enc_temp==1) enc_data1=2;
	CPI  R16,1
	BRNE _0x3C
	LDI  R30,LOW(2)
	MOV  R10,R30
; 0000 00CD     if(enc_temp==2) enc_data1=1;
_0x3C:
	CPI  R16,2
	BRNE _0x3D
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 00CE    }
_0x3D:
; 0000 00CF 
; 0000 00D0   enc_state1 = enc_temp;  //   
_0x3B:
	MOV  R8,R16
; 0000 00D1  }
	RJMP _0x2000001
; .FEND
;void EncoderScan2 (void)  //  2
; 0000 00D3  {
_EncoderScan2:
; .FSTART _EncoderScan2
; 0000 00D4   unsigned char enc_temp=0;         //
; 0000 00D5 
; 0000 00D6   if(enc_A2){enc_temp|=(1<<0);}      //  
	ST   -Y,R16
;	enc_temp -> R16
	LDI  R16,0
	SBIC 0x19,4
	ORI  R16,LOW(1)
; 0000 00D7   if(enc_B2){enc_temp|=(1<<1);}      //  
	SBIC 0x19,5
	ORI  R16,LOW(2)
; 0000 00D8 
; 0000 00D9   if(enc_state2==0)               // 
	TST  R9
	BRNE _0x40
; 0000 00DA    {
; 0000 00DB     if(enc_temp==2) enc_data2=2;
	CPI  R16,2
	BRNE _0x41
	LDI  R30,LOW(2)
	MOV  R11,R30
; 0000 00DC     if(enc_temp==1) enc_data2=1;
_0x41:
	CPI  R16,1
	BRNE _0x42
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 00DD    }
_0x42:
; 0000 00DE   if(enc_state2==3)               // 
_0x40:
	LDI  R30,LOW(3)
	CP   R30,R9
	BRNE _0x43
; 0000 00DF    {
; 0000 00E0     if(enc_temp==1) enc_data2=2;
	CPI  R16,1
	BRNE _0x44
	LDI  R30,LOW(2)
	MOV  R11,R30
; 0000 00E1     if(enc_temp==2) enc_data2=1;
_0x44:
	CPI  R16,2
	BRNE _0x45
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 00E2    }
_0x45:
; 0000 00E3 
; 0000 00E4   enc_state2 = enc_temp;  //   
_0x43:
	MOV  R9,R16
; 0000 00E5  }
_0x2000001:
	LD   R16,Y+
	RET
; .FEND
;void LED_bar(unsigned char level)
; 0000 00E7  {
_LED_bar:
; .FSTART _LED_bar
; 0000 00E8   unsigned char bar[8]={0,0,0,0,0,0,0,0}; //  
; 0000 00E9   unsigned char n=0;  //   
; 0000 00EA 
; 0000 00EB   if(level<=10 && level>=0) {n=1;} // 7 
	ST   -Y,R26
	SBIW R28,8
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	STD  Y+4,R30
	STD  Y+5,R30
	STD  Y+6,R30
	STD  Y+7,R30
	ST   -Y,R16
;	level -> Y+9
;	bar -> Y+1
;	n -> R16
	LDI  R16,0
	LDD  R26,Y+9
	CPI  R26,LOW(0xB)
	BRSH _0x47
	CPI  R26,0
	BRSH _0x48
_0x47:
	RJMP _0x46
_0x48:
	LDI  R16,LOW(1)
; 0000 00EC   if(level<=20 && level>10) {n=2;} // 6 
_0x46:
	LDD  R26,Y+9
	CPI  R26,LOW(0x15)
	BRSH _0x4A
	CPI  R26,LOW(0xB)
	BRSH _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
	LDI  R16,LOW(2)
; 0000 00ED   if(level<=30 && level>20) {n=3;} // 5 
_0x49:
	LDD  R26,Y+9
	CPI  R26,LOW(0x1F)
	BRSH _0x4D
	CPI  R26,LOW(0x15)
	BRSH _0x4E
_0x4D:
	RJMP _0x4C
_0x4E:
	LDI  R16,LOW(3)
; 0000 00EE   if(level<=40 && level>30) {n=4;} // 4 
_0x4C:
	LDD  R26,Y+9
	CPI  R26,LOW(0x29)
	BRSH _0x50
	CPI  R26,LOW(0x1F)
	BRSH _0x51
_0x50:
	RJMP _0x4F
_0x51:
	LDI  R16,LOW(4)
; 0000 00EF   if(level<=50 && level>40) {n=5;} // 3 
_0x4F:
	LDD  R26,Y+9
	CPI  R26,LOW(0x33)
	BRSH _0x53
	CPI  R26,LOW(0x29)
	BRSH _0x54
_0x53:
	RJMP _0x52
_0x54:
	LDI  R16,LOW(5)
; 0000 00F0   if(level<=60 && level>50) {n=6;} // 2 
_0x52:
	LDD  R26,Y+9
	CPI  R26,LOW(0x3D)
	BRSH _0x56
	CPI  R26,LOW(0x33)
	BRSH _0x57
_0x56:
	RJMP _0x55
_0x57:
	LDI  R16,LOW(6)
; 0000 00F1   if(level<=70 && level>60) {n=7;} // 1 
_0x55:
	LDD  R26,Y+9
	CPI  R26,LOW(0x47)
	BRSH _0x59
	CPI  R26,LOW(0x3D)
	BRSH _0x5A
_0x59:
	RJMP _0x58
_0x5A:
	LDI  R16,LOW(7)
; 0000 00F2   if(level<=80 && level>70) {n=8;} //  
_0x58:
	LDD  R26,Y+9
	CPI  R26,LOW(0x51)
	BRSH _0x5C
	CPI  R26,LOW(0x47)
	BRSH _0x5D
_0x5C:
	RJMP _0x5B
_0x5D:
	LDI  R16,LOW(8)
; 0000 00F3 
; 0000 00F4   for(; n<8; n++) {bar[n]=1;}      // 
_0x5B:
_0x5F:
	CPI  R16,8
	BRSH _0x60
	MOV  R26,R28
	SUBI R26,-(1)
	ADD  R26,R16
	LDI  R30,LOW(1)
	ST   X,R30
	SUBI R16,-1
	RJMP _0x5F
_0x60:
; 0000 00F5 
; 0000 00F6   //  
; 0000 00F7   LED_1=bar[7];LED_2=bar[6];LED_3=bar[5];LED_4=bar[4];
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x61
	CBI  0x1B,0
	RJMP _0x62
_0x61:
	SBI  0x1B,0
_0x62:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x63
	CBI  0x1B,1
	RJMP _0x64
_0x63:
	SBI  0x1B,1
_0x64:
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0x65
	CBI  0x1B,2
	RJMP _0x66
_0x65:
	SBI  0x1B,2
_0x66:
	LDD  R30,Y+5
	CPI  R30,0
	BRNE _0x67
	CBI  0x18,0
	RJMP _0x68
_0x67:
	SBI  0x18,0
_0x68:
; 0000 00F8   LED_5=bar[3];LED_6=bar[2];LED_7=bar[1];
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0x69
	CBI  0x18,1
	RJMP _0x6A
_0x69:
	SBI  0x18,1
_0x6A:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x6B
	CBI  0x18,2
	RJMP _0x6C
_0x6B:
	SBI  0x18,2
_0x6C:
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x6D
	CBI  0x18,3
	RJMP _0x6E
_0x6D:
	SBI  0x18,3
_0x6E:
; 0000 00F9  }
	LDD  R16,Y+0
	ADIW R28,10
	RET
; .FEND
;void save_vol (void) //  
; 0000 00FB  {
_save_vol:
; .FSTART _save_vol
; 0000 00FC   TCNT0=0x00;   //   
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00FD   timer=0;      //  
	CLR  R6
; 0000 00FE   #asm("sei")  //   
	sei
; 0000 00FF  }
	RET
; .FEND
;void TWI_start (void)      //   
; 0000 0101  {
_TWI_start:
; .FSTART _TWI_start
; 0000 0102   #define WHI      0   //   i2c
; 0000 0103   #define WLO      1   //    i2c
; 0000 0104   PDATA=0;             // SDA  
	CBI  0x1B,6
; 0000 0105   PCLOCK=0;            // SCL  
	CBI  0x1B,7
; 0000 0106   SCL=WHI;             // 
	CBI  0x1A,7
; 0000 0107   #asm("nop")
	nop
; 0000 0108   #asm("nop")
	nop
; 0000 0109   SDA=WLO;             // 
	SBI  0x1A,6
; 0000 010A   #asm("nop")
	nop
; 0000 010B   #asm("nop")
	nop
; 0000 010C   SCL=WLO;             // 
	SBI  0x1A,7
; 0000 010D   #asm("nop")
	nop
; 0000 010E  }
	RET
; .FEND
;void TWI_send (unsigned char data) //  
; 0000 0110  {
_TWI_send:
; .FSTART _TWI_send
; 0000 0111   unsigned char tmp;     //
; 0000 0112 
; 0000 0113   for(tmp=0; tmp<8; tmp++)   // 
	ST   -Y,R26
	ST   -Y,R16
;	data -> Y+1
;	tmp -> R16
	LDI  R16,LOW(0)
_0x7A:
	CPI  R16,8
	BRSH _0x7B
; 0000 0114    {
; 0000 0115     if(data & 128)     // 
	LDD  R30,Y+1
	ANDI R30,LOW(0x80)
	BREQ _0x7C
; 0000 0116      {SDA=WHI;}        //  = 1
	CBI  0x1A,6
; 0000 0117     else
	RJMP _0x7F
_0x7C:
; 0000 0118      {SDA=WLO;}        //  = 0
	SBI  0x1A,6
_0x7F:
; 0000 0119 
; 0000 011A     #asm("nop")  #asm("nop")
	nop
	nop
; 0000 011B 
; 0000 011C     SCL=WHI;           // 
	CBI  0x1A,7
; 0000 011D     data=data<<1;      // 
	LDD  R30,Y+1
	LSL  R30
	STD  Y+1,R30
; 0000 011E     SCL=WLO;           // 
	SBI  0x1A,7
; 0000 011F    }
	SUBI R16,-1
	RJMP _0x7A
_0x7B:
; 0000 0120 
; 0000 0121   #asm("nop")  #asm("nop")
	nop
	nop
; 0000 0122 
; 0000 0123   //  Acknowledge
; 0000 0124   SDA=WHI;  #asm("nop")  #asm("nop")
	CBI  0x1A,6
	nop
	nop
; 0000 0125   SCL=WHI;  #asm("nop")  #asm("nop")
	CBI  0x1A,7
	nop
	nop
; 0000 0126   SCL=WLO;  #asm("nop")  #asm("nop")
	SBI  0x1A,7
	nop
	nop
; 0000 0127  }
	LDD  R16,Y+0
	ADIW R28,2
	RET
; .FEND
;void TWI_stop (void)   //   
; 0000 0129  {
_TWI_stop:
; .FSTART _TWI_stop
; 0000 012A   PDATA=0;             // SDA  
	CBI  0x1B,6
; 0000 012B   PCLOCK=0;            // SCL  
	CBI  0x1B,7
; 0000 012C   SDA=WLO;             // 
	SBI  0x1A,6
; 0000 012D   #asm("nop")
	nop
; 0000 012E   #asm("nop")
	nop
; 0000 012F   SCL=WHI;             // 
	CBI  0x1A,7
; 0000 0130   #asm("nop")
	nop
; 0000 0131   #asm("nop")
	nop
; 0000 0132   SDA=WHI;             // 
	CBI  0x1A,6
; 0000 0133   #asm("nop")
	nop
; 0000 0134  }
	RET
; .FEND
;void TDA_send (unsigned char value)
; 0000 0136  {
_TDA_send:
; .FSTART _TDA_send
; 0000 0137   TWI_start();       // 
	ST   -Y,R26
;	value -> Y+0
	RCALL _TWI_start
; 0000 0138   TWI_send(0x88);    //
	LDI  R26,LOW(136)
	RCALL _TWI_send
; 0000 0139   TWI_send(0x10);    //
	LDI  R26,LOW(16)
	RCALL _TWI_send
; 0000 013A   TWI_send(value);   //1-
	LD   R26,Y
	RCALL _TWI_send
; 0000 013B   TWI_send(value);   //2-
	LD   R26,Y
	RCALL _TWI_send
; 0000 013C   TWI_send(value);   //3-
	LD   R26,Y
	RCALL _TWI_send
; 0000 013D   TWI_send(value);   //4-
	LD   R26,Y
	RCALL _TWI_send
; 0000 013E   TWI_send(value);   //5-
	LD   R26,Y
	RCALL _TWI_send
; 0000 013F   TWI_send(value);   //6-
	LD   R26,Y
	RCALL _TWI_send
; 0000 0140   TWI_stop();        // 
	RCALL _TWI_stop
; 0000 0141  }
	ADIW R28,1
	RET
; .FEND
;

	.ESEG
_e_vol:
	.BYTE 0x1
_e_mute:
	.BYTE 0x1

	.CSEG

	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
